const mongoose = require('mongoose');
const { toJSON, paginate } = require('./plugins');

/**
 * @constructor
 */
const assetSchema = new mongoose.Schema(
  {
    name: {
      type: String,
      required: true,
      trim: true,
    },
    type: {
      type: String,
      required: true,
    },
    data: {
      type: mongoose.Schema.Types.Mixed,
    },
    created_by: {
      type: mongoose.Schema.Types.ObjectId,
      ref: 'User',
      required: true,
    },
  },
  {
    timestamps: true,
  }
);

assetSchema.plugin(toJSON);
assetSchema.plugin(paginate);

const Asset = mongoose.model('Asset', assetSchema);

module.exports = Asset;
